// Generated by CoffeeScript 1.6.2
(function() {
  var Async, Biscotto, Generator, Parser, fs, path, util, walkdir, _;

  fs = require('fs');

  util = require('util');

  path = require('path');

  walkdir = require('walkdir');

  Async = require('async');

  _ = require('underscore');

  Parser = require('./parser');

  Generator = require('./generator');

  module.exports = Biscotto = (function() {
    function Biscotto() {}

    Biscotto.version = function() {
      return 'v' + JSON.parse(fs.readFileSync(path.join(__dirname, '..', 'package.json'), 'utf-8'))['version'];
    };

    Biscotto.run = function(done, file, analytics, homepage) {
      var biscottoopts, bool, config, configs, error, option, _i, _len, _ref;

      if (analytics == null) {
        analytics = false;
      }
      if (homepage == null) {
        homepage = false;
      }
      biscottoopts = {
        _: []
      };
      try {
        if ((fs.existsSync || path.existsSync)('.biscottoopts')) {
          configs = fs.readFileSync('.biscottoopts', 'utf8');
          _ref = configs.split('\n');
          for (_i = 0, _len = _ref.length; _i < _len; _i++) {
            config = _ref[_i];
            if (option = /^-{1,2}([\w-]+)\s+(['"])?(.*?)\2?$/.exec(config)) {
              biscottoopts[option[1]] = option[3];
            } else if (bool = /^-{1,2}([\w-]+)\s*$/.exec(config)) {
              biscottoopts[bool[1]] = true;
            } else if (config !== '') {
              biscottoopts._.push(config);
            }
          }
        }
        return Async.parallel({
          inputs: this.detectSources,
          readme: this.detectReadme,
          extras: this.detectExtras,
          name: this.detectName
        }, function(err, defaults) {
          var arg, args, argv, connect, error, extra, extraUsage, filename, generator, input, optimist, options, parser, port, stats, _j, _k, _l, _len1, _len2, _len3, _ref1, _ref2;

          extraUsage = defaults.extras.length === 0 ? '' : "- " + (defaults.extras.join(' '));
          optimist = require('optimist').usage("Usage:   $0 [options] [source_files [- extra_files]]\nDefault: $0 [options] " + (defaults.inputs.join(' ')) + " " + extraUsage).options('r', {
            alias: 'readme',
            describe: 'The readme file used',
            "default": biscottoopts.readme || biscottoopts.r || defaults.readme
          }).options('n', {
            alias: 'name',
            describe: 'The project name used',
            "default": biscottoopts.name || biscottoopts.n || defaults.name
          }).options('q', {
            alias: 'quiet',
            describe: 'Show no warnings',
            boolean: true,
            "default": biscottoopts.quiet || false
          }).options('o', {
            alias: 'output-dir',
            describe: 'The output directory',
            "default": biscottoopts['output-dir'] || biscottoopts.o || './doc'
          }).options('a', {
            alias: 'analytics',
            describe: 'The Google analytics ID',
            "default": biscottoopts.analytics || biscottoopts.a || false
          }).options('v', {
            alias: 'verbose',
            describe: 'Show parsing errors',
            boolean: true,
            "default": biscottoopts.verbose || biscottoopts.v || false
          }).options('d', {
            alias: 'debug',
            describe: 'Show stacktraces and converted CoffeeScript source',
            boolean: true,
            "default": biscottoopts.debug || biscottoopts.d || false
          }).options('h', {
            alias: 'help',
            describe: 'Show the help'
          }).options('cautious', {
            describe: 'Don\'t attempt to parse singleline comments',
            boolean: true,
            "default": biscottoopts.cautious || false
          }).options('s', {
            alias: 'server',
            describe: 'Start a documentation server'
          }).options('j', {
            alias: 'json',
            describe: 'The location (including filename) of optional JSON output'
          }).options('noOutput', {
            boolean: true,
            describe: 'Generates no documentation output'
          }).options('stats', {
            boolean: true,
            describe: 'Returns stats on documentation, such as total coverage'
          }).options('missing', {
            boolean: true,
            describe: 'Lists which elements are missing documentation'
          }).options('private', {
            boolean: true,
            "default": biscottoopts["private"] || false,
            describe: 'Show private methods'
          }).options('internal', {
            boolean: true,
            "default": biscottoopts.internal || false,
            describe: 'Show internal methods'
          })["default"]('title', biscottoopts.title || 'CoffeeScript API Documentation');
          argv = optimist.argv;
          if (argv.h) {
            return console.log(optimist.help());
          } else if (argv.s) {
            port = argv.s === true ? 8080 : argv.s;
            connect = require('connect');
            connect.createServer(connect["static"](argv.o)).listen(port);
            return console.log('Biscotto documentation from %s is available at http://localhost:%d', argv.o, port);
          } else {
            options = {
              inputs: [],
              output: argv.o,
              json: argv.j || "",
              extras: [],
              name: argv.n,
              readme: argv.r,
              title: argv.title,
              quiet: argv.q,
              "private": argv["private"],
              internal: argv.internal,
              noOutput: argv.noOutput,
              missing: argv.missing,
              verbose: argv.v,
              debug: argv.d,
              cautious: argv.cautious,
              homepage: homepage,
              analytics: analytics || argv.a
            };
            extra = false;
            args = argv._.length !== 0 && /.+biscotto$/.test(process.argv[1]) ? argv._ : biscottoopts._;
            for (_j = 0, _len1 = args.length; _j < _len1; _j++) {
              arg = args[_j];
              if (arg === '-') {
                extra = true;
              } else {
                if (extra) {
                  options.extras.push(arg);
                } else {
                  options.inputs.push(arg);
                }
              }
            }
            if (options.inputs.length === 0) {
              options.inputs = defaults.inputs;
            }
            if (options.extras.length === 0) {
              options.extras = defaults.extras;
            }
            parser = new Parser(options);
            _ref1 = options.inputs;
            for (_k = 0, _len2 = _ref1.length; _k < _len2; _k++) {
              input = _ref1[_k];
              if ((fs.existsSync || path.existsSync)(input)) {
                stats = fs.lstatSync(input);
                if (stats.isDirectory()) {
                  _ref2 = walkdir.sync(input);
                  for (_l = 0, _len3 = _ref2.length; _l < _len3; _l++) {
                    filename = _ref2[_l];
                    if (filename.match(/\._?coffee$/)) {
                      try {
                        parser.parseFile(filename.substring(process.cwd().length + 1));
                      } catch (_error) {
                        error = _error;
                        if (options.debug) {
                          throw error;
                        }
                        console.log("Cannot parse file " + filename + ": " + error.message);
                      }
                    }
                  }
                } else {
                  if (input.match(/\._?coffee$/)) {
                    try {
                      parser.parseFile(input);
                    } catch (_error) {
                      error = _error;
                      if (options.debug) {
                        throw error;
                      }
                      console.log("Cannot parse file " + filename + ": " + error.message);
                    }
                  }
                }
              }
            }
            generator = new Generator(parser, options);
            generator.generate(file);
            if (options.json && options.json.length) {
              fs.writeFileSync(options.json, JSON.stringify(parser.toJSON(generator.referencer), null, "    "));
            }
            if (!options.quiet) {
              parser.showResult(generator);
            }
            if (done) {
              return done();
            }
          }
        });
      } catch (_error) {
        error = _error;
        if (done) {
          done(error);
        }
        console.log("Cannot generate documentation: " + error.message);
        throw error;
      }
    };

    Biscotto.script = function() {
      return this.biscottoScript || (this.biscottoScript = fs.readFileSync(path.join(__dirname, '..', 'theme', 'default', 'assets', 'biscotto.js'), 'utf-8'));
    };

    Biscotto.style = function() {
      return this.biscottoStyle || (this.biscottoStyle = fs.readFileSync(path.join(__dirname, '..', 'theme', 'default', 'assets', 'biscotto.css'), 'utf-8'));
    };

    Biscotto.detectSources = function(done) {
      return Async.filter(['src', 'lib', 'app'], fs.exists || path.exists, function(results) {
        if (results.length === 0) {
          results.push('.');
        }
        return done(null, results);
      });
    };

    Biscotto.detectReadme = function(done) {
      return Async.filter(['README.markdown', 'README.md', 'README', 'readme.markdown', 'readme.md', 'readme'], fs.exists || path.exists, function(results) {
        return done(null, _.first(results) || '');
      });
    };

    Biscotto.detectExtras = function(done) {
      return Async.filter(['CHANGELOG.markdown', 'CHANGELOG.md', 'AUTHORS', 'AUTHORS.md', 'AUTHORS.markdown', 'LICENSE', 'LICENSE.md', 'LICENSE.markdown', 'LICENSE.MIT', 'LICENSE.GPL'], fs.exists || path.exists, function(results) {
        return done(null, results);
      });
    };

    Biscotto.detectName = function(done) {
      var name;

      if ((fs.exists || path.exists)('package.json')) {
        name = JSON.parse(fs.readFileSync(path.join(__dirname, '..', 'package.json'), 'utf-8'))['name'];
      } else {
        name = path.basename(process.cwd());
      }
      return done(null, name.charAt(0).toUpperCase() + name.slice(1));
    };

    return Biscotto;

  })();

}).call(this);
