// Generated by CoffeeScript 1.6.2
(function() {
  var Class, Doc, Method, Node, Property, Variable, VirtualMethod, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Node = require('./node');

  Method = require('./method');

  VirtualMethod = require('./virtual_method');

  Variable = require('./variable');

  Property = require('./property');

  Doc = require('./doc');

  _ = require('underscore');

  module.exports = Class = (function(_super) {
    __extends(Class, _super);

    function Class(node, fileName, options, comment) {
      var doc, error, exp, method, name, previousExp, previousProp, prop, property, swallowedDoc, type, variable, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref10, _ref11, _ref12, _ref13, _ref14, _ref15, _ref16, _ref17, _ref18, _ref19, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;

      this.node = node;
      this.fileName = fileName;
      this.options = options;
      try {
        this.methods = [];
        this.variables = [];
        this.properties = [];
        this.doc = new Doc(comment, this.options);
        if (this.doc.methods) {
          _ref1 = (_ref = this.doc) != null ? _ref.methods : void 0;
          for (_i = 0, _len = _ref1.length; _i < _len; _i++) {
            method = _ref1[_i];
            this.methods.push(new VirtualMethod(this, method, this.options));
          }
        }
        previousExp = null;
        _ref2 = this.node.body.expressions;
        for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
          exp = _ref2[_j];
          switch (exp.constructor.name) {
            case 'Assign':
              if ((previousExp != null ? previousExp.constructor.name : void 0) === 'Comment') {
                doc = previousExp;
              }
              doc || (doc = swallowedDoc);
              switch ((_ref3 = exp.value) != null ? _ref3.constructor.name : void 0) {
                case 'Code':
                  if (exp.variable.base.value === 'this') {
                    this.methods.push(new Method(this, exp, this.options, doc));
                  }
                  break;
                case 'Value':
                  this.variables.push(new Variable(this, exp, this.options, true, doc));
              }
              doc = null;
              break;
            case 'Value':
              previousProp = null;
              _ref4 = exp.base.properties;
              for (_k = 0, _len2 = _ref4.length; _k < _len2; _k++) {
                prop = _ref4[_k];
                if ((previousProp != null ? previousProp.constructor.name : void 0) === 'Comment') {
                  doc = previousProp;
                }
                doc || (doc = swallowedDoc);
                switch ((_ref5 = prop.value) != null ? _ref5.constructor.name : void 0) {
                  case 'Code':
                    this.methods.push(new Method(this, prop, this.options, doc));
                    break;
                  case 'Value':
                    variable = new Variable(this, prop, this.options, false, doc);
                    if ((_ref6 = variable.doc) != null ? _ref6.property : void 0) {
                      property = new Property(this, prop, this.options, variable.getName(), doc);
                      property.setter = true;
                      property.getter = true;
                      this.properties.push(property);
                    } else {
                      this.variables.push(variable);
                    }
                }
                doc = null;
                previousProp = prop;
              }
              break;
            case 'Call':
              if ((previousExp != null ? previousExp.constructor.name : void 0) === 'Comment') {
                doc = previousExp;
              }
              doc || (doc = swallowedDoc);
              type = (_ref7 = exp.variable) != null ? (_ref8 = _ref7.base) != null ? _ref8.value : void 0 : void 0;
              name = (_ref9 = exp.args) != null ? (_ref10 = _ref9[0]) != null ? (_ref11 = _ref10.base) != null ? (_ref12 = _ref11.properties) != null ? (_ref13 = _ref12[0]) != null ? (_ref14 = _ref13.variable) != null ? (_ref15 = _ref14.base) != null ? _ref15.value : void 0 : void 0 : void 0 : void 0 : void 0 : void 0 : void 0;
              swallowedDoc = (_ref16 = exp.args) != null ? (_ref17 = _ref16[0]) != null ? (_ref18 = _ref17.base) != null ? (_ref19 = _ref18.properties) != null ? _ref19[1] : void 0 : void 0 : void 0 : void 0;
              if (name && (type === 'set' || type === 'get')) {
                property = _.find(this.properties, function(p) {
                  return p.name === name;
                });
                if (!property) {
                  property = new Property(this, exp, this.options, name, doc);
                  this.properties.push(property);
                }
                if (type === 'set') {
                  property.setter = true;
                }
                if (type === 'get') {
                  property.getter = true;
                }
                doc = null;
              }
          }
          previousExp = exp;
        }
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          console.warn('Create class error:', this.node, error);
        }
      }
    }

    Class.prototype.getFileName = function() {
      return this.fileName;
    };

    Class.prototype.getDoc = function() {
      return this.doc;
    };

    Class.prototype.getFullName = function() {
      return this.getClassName();
    };

    Class.prototype.getClassName = function() {
      var error, outer, prop, _i, _j, _len, _len1, _ref, _ref1;

      try {
        if (!(this.className || !this.node.variable)) {
          this.className = this.node.variable.base.value;
          if (this.className === 'this') {
            outer = this.findAncestor('Class');
            if (outer) {
              this.className = outer.variable.base.value;
              _ref = outer.variable.properties;
              for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                prop = _ref[_i];
                this.className += "." + prop.name.value;
              }
            } else {
              this.className = '';
            }
          }
          _ref1 = this.node.variable.properties;
          for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
            prop = _ref1[_j];
            this.className += "." + prop.name.value;
          }
        }
        return this.className;
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          return console.warn("Get class classname error at " + this.fileName + ":", this.node, error);
        }
      }
    };

    Class.prototype.getName = function() {
      var error;

      try {
        if (!this.name) {
          this.name = this.getClassName().split('.').pop();
        }
        return this.name;
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          return console.warn("Get class name error at " + this.fileName + ":", this.node, error);
        }
      }
    };

    Class.prototype.getNamespace = function() {
      var error;

      try {
        if (!this.namespace) {
          this.namespace = this.getClassName().split('.');
          this.namespace.pop();
          this.namespace = this.namespace.join('.');
        }
        return this.namespace;
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          return console.warn("Get class namespace error at " + this.fileName + ":", this.node, error);
        }
      }
    };

    Class.prototype.getParentClassName = function() {
      var error, outer, prop, _i, _j, _len, _len1, _ref, _ref1;

      try {
        if (!this.parentClassName) {
          if (this.node.parent) {
            this.parentClassName = this.node.parent.base.value;
            if (this.parentClassName === 'this') {
              outer = this.findAncestor('Class');
              if (outer) {
                this.parentClassName = outer.parent.base.value;
                _ref = outer.parent.properties;
                for (_i = 0, _len = _ref.length; _i < _len; _i++) {
                  prop = _ref[_i];
                  this.parentClassName += "." + prop.name.value;
                }
              } else {
                this.parentClassName = '';
              }
            }
            _ref1 = this.node.parent.properties;
            for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
              prop = _ref1[_j];
              this.parentClassName += "." + prop.name.value;
            }
          }
        }
        return this.parentClassName;
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          return console.warn("Get class parent classname error at " + this.fileName + ":", this.node, error);
        }
      }
    };

    Class.prototype.getMethods = function() {
      var _this = this;

      return _.filter(this.methods, function(method) {
        if (!_this.options["private"] && method.doc.status === "Private") {
          return false;
        } else if (!_this.options.internal && method.doc.status === "Internal") {
          return false;
        } else {
          return true;
        }
      });
    };

    Class.prototype.getVariables = function() {
      return this.variables;
    };

    Class.prototype.toJSON = function() {
      var json, method, property, variable, _i, _j, _k, _len, _len1, _len2, _ref, _ref1, _ref2;

      json = {
        file: this.getFileName(),
        doc: this.getDoc().toJSON(),
        "class": {
          className: this.getClassName(),
          name: this.getName(),
          namespace: this.getNamespace(),
          parent: this.getParentClassName()
        },
        methods: [],
        variables: [],
        properties: []
      };
      _ref = this.getMethods();
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        method = _ref[_i];
        json.methods.push(method.toJSON());
      }
      _ref1 = this.getVariables();
      for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
        variable = _ref1[_j];
        json.variables.push(variable.toJSON());
      }
      _ref2 = this.properties;
      for (_k = 0, _len2 = _ref2.length; _k < _len2; _k++) {
        property = _ref2[_k];
        json.properties.push(property.toJSON());
      }
      return json;
    };

    return Class;

  })(Node);

}).call(this);
