// Generated by CoffeeScript 1.6.2
(function() {
  var Class, Doc, File, Method, Path, Variable,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Path = require('path');

  Class = require('./class');

  Method = require('./method');

  Variable = require('./variable');

  Doc = require('./doc');

  module.exports = File = (function(_super) {
    __extends(File, _super);

    function File(node, fileName, options) {
      var doc, error, exp, previousExp, previousProp, prop, _i, _j, _len, _len1, _ref, _ref1, _ref2, _ref3;

      this.node = node;
      this.fileName = fileName;
      this.options = options;
      try {
        this.methods = [];
        this.variables = [];
        previousExp = null;
        _ref = this.node.expressions;
        for (_i = 0, _len = _ref.length; _i < _len; _i++) {
          exp = _ref[_i];
          switch (exp.constructor.name) {
            case 'Assign':
              if ((previousExp != null ? previousExp.constructor.name : void 0) === 'Comment') {
                doc = previousExp;
              }
              switch ((_ref1 = exp.value) != null ? _ref1.constructor.name : void 0) {
                case 'Code':
                  this.methods.push(new Method(this, exp, this.options, doc));
                  break;
                case 'Value':
                  if (exp.value.base.value) {
                    this.variables.push(new Variable(this, exp, this.options, true, doc));
                  }
              }
              doc = null;
              break;
            case 'Value':
              previousProp = null;
              _ref2 = exp.base.properties;
              for (_j = 0, _len1 = _ref2.length; _j < _len1; _j++) {
                prop = _ref2[_j];
                if ((previousProp != null ? previousProp.constructor.name : void 0) === 'Comment') {
                  doc = previousProp;
                }
                if (((_ref3 = prop.value) != null ? _ref3.constructor.name : void 0) === 'Code') {
                  this.methods.push(new Method(this, prop, this.options, doc));
                }
                doc = null;
                previousProp = prop;
              }
          }
          previousExp = exp;
        }
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          console.warn('File class error:', this.node, error);
        }
      }
    }

    File.prototype.getFullName = function() {
      var fullName, input, _i, _len, _ref;

      fullName = this.fileName;
      _ref = this.options.inputs;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        input = _ref[_i];
        input = input.replace(/^\.[\\/]/, '');
        if (!RegExp("" + Path.sep + "$").test(input)) {
          input = input + Path.sep;
        }
        input = input.replace(/([.?*+^$[\]\\(){}|-])/g, "\\$1");
        fullName = fullName.replace(new RegExp(input), '');
      }
      return fullName.replace(Path.sep, '/');
    };

    File.prototype.getFileName = function() {
      return Path.basename(this.getFullName());
    };

    File.prototype.getPath = function() {
      var path;

      path = Path.dirname(this.getFullName());
      if (path === '.') {
        path = '';
      }
      return path;
    };

    File.prototype.isEmpty = function() {
      return this.getMethods().length === 0 && this.getVariables().length === 0;
    };

    File.prototype.toJSON = function() {
      var json, method, variable, _i, _j, _len, _len1, _ref, _ref1;

      json = {
        file: this.getFileName(),
        path: this.getPath(),
        methods: [],
        variables: []
      };
      _ref = this.getMethods();
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        method = _ref[_i];
        json.methods.push(method.toJSON());
      }
      _ref1 = this.getVariables();
      for (_j = 0, _len1 = _ref1.length; _j < _len1; _j++) {
        variable = _ref1[_j];
        json.variables.push(variable.toJSON());
      }
      return json;
    };

    return File;

  })(Class);

}).call(this);
