// Generated by CoffeeScript 1.6.2
(function() {
  var Doc, Node, Property, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Node = require('./node');

  Doc = require('./doc');

  _ = require('underscore');

  _.str = require('underscore.string');

  module.exports = Property = (function(_super) {
    __extends(Property, _super);

    function Property(entity, node, options, name, comment) {
      this.entity = entity;
      this.node = node;
      this.options = options;
      this.name = name;
      this.doc = new Doc(comment, this.options);
      this.setter = false;
      this.getter = false;
    }

    Property.prototype.getSignature = function() {
      var error;

      try {
        if (!this.signature) {
          this.signature = '';
          if (this.doc) {
            this.signature += this.doc.property ? "(" + (_.str.escapeHTML(this.doc.property)) + ") " : "(?) ";
          }
          this.signature += "<strong>" + this.name + "</strong>";
        }
        return this.signature;
      } catch (_error) {
        error = _error;
        if (this.options.verbose) {
          return console.warn('Get property signature error:', this.node, error);
        }
      }
    };

    Property.prototype.toJSON = function() {
      return {
        name: this.name,
        signature: this.getSignature(),
        setter: this.setter,
        getter: this.getter,
        doc: this.doc
      };
    };

    return Property;

  })(Node);

}).call(this);
