// Generated by CoffeeScript 1.6.2
(function() {
  var Markdown, marked;

  marked = require('marked');

  module.exports = Markdown = (function() {
    function Markdown() {}

    Markdown.limitedTags = 'a,abbr,acronym,b,big,cite,code,del,em,i,ins,sub,sup,span,small,strike,strong,q,tt,u';

    Markdown.convert = function(markdown, limit, allowed) {
      var html;

      if (limit == null) {
        limit = false;
      }
      if (allowed == null) {
        allowed = Markdown.limitedTags;
      }
      if (markdown === void 0) {
        return;
      }
      html = marked(markdown);
      if (limit) {
        html = html.replace(/\n/, '');
        html = Markdown.limit(html, allowed);
      }
      html = html.replace(/(?:\n+)?<(\/?p)>(?:\n+)?/mg, '<$1>');
      return html;
    };

    Markdown.limit = function(html, allowed) {
      allowed = allowed.split(',');
      return html.replace(/<([a-z]+)>(.+?)<\/\1>/, function(match, tag, text) {
        if (allowed.indexOf(tag) === -1) {
          return text;
        } else {
          return match;
        }
      });
    };

    return Markdown;

  })();

}).call(this);
