// Generated by CoffeeScript 1.6.2
(function() {
  var Templater, fs, hamlc, mkdirp, path, walkdir, _;

  fs = require('fs');

  path = require('path');

  mkdirp = require('mkdirp');

  _ = require('underscore');

  _.str = require('underscore.string');

  walkdir = require('walkdir');

  hamlc = require('haml-coffee');

  module.exports = Templater = (function() {
    function Templater(options, referencer, parser) {
      var filename, match, _i, _len, _ref;

      this.options = options;
      this.referencer = referencer;
      this.parser = parser;
      this.JST = [];
      this.globalContext = {
        biscottoVersion: 'v' + JSON.parse(fs.readFileSync(path.join(__dirname, '..', '..', 'package.json'), 'utf-8'))['version'],
        generationDate: new Date().toString(),
        JST: this.JST,
        underscore: _,
        str: _.str,
        title: this.options.title,
        referencer: this.referencer,
        analytics: this.options.analytics,
        fileCount: this.parser.files.length,
        classCount: this.parser.classes.length,
        mixinCount: this.parser.mixins.length,
        methodCount: this.parser.getAllMethods().length,
        extraCount: _.union([this.options.readme], this.options.extras).length
      };
      _ref = walkdir.sync(path.join(__dirname, '..', '..', 'theme', 'default', 'templates'));
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        filename = _ref[_i];
        if (match = /theme[/\\]default[/\\]templates[/\\](.+).hamlc$/.exec(filename)) {
          this.JST[match[1]] = hamlc.compile(fs.readFileSync(filename, 'utf-8'));
        }
      }
    }

    Templater.prototype.redirect = function(file) {
      return this.file = file;
    };

    Templater.prototype.render = function(template, context, filename) {
      var dir, file, html,
        _this = this;

      if (context == null) {
        context = {};
      }
      if (filename == null) {
        filename = '';
      }
      html = this.JST[template](_.extend(this.globalContext, context));
      if (!_.isEmpty(filename)) {
        if (this.file) {
          this.file(filename, html);
        } else {
          if (!this.options.noOutput) {
            file = path.join(this.options.output, filename);
            dir = path.dirname(file);
            mkdirp(dir, function(err) {
              if (err) {
                return console.error("[ERROR] Cannot create directory " + dir + ": " + err);
              } else {
                return fs.writeFile(file, html);
              }
            });
          }
        }
      }
      return html;
    };

    return Templater;

  })();

}).call(this);
